<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
       <el-form-item :label="t('FactoryModeling.WorkTeam.detailDialogJobNoLabel')" prop="userId">
         <el-select
           v-model="formData.userId"
           clearable
           filterable
           :placeholder="t('FactoryModeling.WorkTeam.detailDialogJobNoPlaceholder')"
         >
           <el-option
             v-for="item in userList"
             :key="item.id"
             :label="item.nickname"
             :value="item.id"
           />
         </el-select>
      </el-form-item>
      <el-form-item prop="userRole">
        <template #label>
          <span>
            {{ t('FactoryModeling.WorkTeam.detailDialogRoleLabel') }}
            <el-tooltip :content="t('FactoryModeling.WorkTeam.detailDialogRoleTooltip')" placement="top">
              <Icon icon="ep:question-filled" />
            </el-tooltip>
          </span>
        </template>
        <el-radio-group v-model="formData.userRole">
          <el-radio
            v-for="dict in getIntDictOptions(DICT_TYPE.MES_WORK_TEAM_USER_ROLE)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.WorkTeam.detailDialogRemarkLabel')" prop="remark">
        <el-input
          v-model="formData.remark"
          :placeholder="t('FactoryModeling.WorkTeam.detailDialogRemarkPlaceholder')"
          type="textarea"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('common.ok') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('common.cancel') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'
import { WorkTeamApi } from '@/api/mes/workteam'
import * as UserApi from "@/api/system/user";

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  workTeamId: undefined,
  userId: undefined,
  userRole: undefined,
  remark: undefined,
})
const formRules = reactive({
  userId: [
    {
      required: true,
      message: t('FactoryModeling.WorkTeam.validatorDetailUserRequired'),
      trigger: 'blur'
    }
  ],
  userRole: [
    {
      required: true,
      message: t('FactoryModeling.WorkTeam.validatorDetailRoleRequired'),
      trigger: 'blur'
    }
  ]
})
const formRef = ref() // 表单 Ref
const userList = ref<UserApi.UserVO[]>([]) // 用户列表
/** 打开弹窗 */
const open = async (type: string, id?: number, workTeamId: number, teamName?:string) => {
  dialogVisible.value = true
  dialogTitle.value =
    t('action.' + type) + ' [' + teamName + '] ' + t('FactoryModeling.WorkTeam.detailDialogMemberSuffix')
  formType.value = type
  resetForm()
  formData.value.workTeamId = workTeamId
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await WorkTeamApi.getWorkTeamDetail(id)
    } finally {
      formLoading.value = false
    }
  }
  // 获得用户列表
  userList.value = await UserApi.getSimpleUserList()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await WorkTeamApi.createWorkTeamDetail(data)
      message.success(t('common.createSuccess'))
    } else {
      await WorkTeamApi.updateWorkTeamDetail(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    workTeamId: undefined,
    userId: undefined,
    userRole: undefined,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>
